------------------------------------Hide the left/right end cap------------------------------------
MainMenuBarArtFrame.LeftEndCap:Hide() 
MainMenuBarArtFrame.RightEndCap:Hide()

------------------------------------Show class icon------------------------------------
hooksecurefunc("UnitFramePortrait_Update",function(self) 
        if self.portrait then 
                if UnitIsPlayer(self.unit) then                 
                        local t = CLASS_ICON_TCOORDS[select(2, UnitClass(self.unit))] 
                        if t then 
                                self.portrait:SetTexture("Interface\\TargetingFrame\\UI-Classes-Circles") 
                                self.portrait:SetTexCoord(unpack(t)) 
                        end 
                else 
                        self.portrait:SetTexCoord(0,1,0,1) 
                end 
        end 
end) 

------------------------------------Show item lvl------------------------------------
local slot = {"Head","Neck","Shoulder","Shirt","Chest","Waist","Legs","Feet","Wrist","Hands","Finger0","Finger1","Trinket0","Trinket1","Back","MainHand","SecondaryHand","Tabard"} 
local ilv = {} 

local function createIlvText(slotName) 
if not ilv[slotName] then 
	local fs = _G[slotName]:CreateFontString(nil, "OVERLAY") 
	fs:SetPoint("BOTTOMLEFT", _G[slotName], "BOTTOMLEFT", -3, -2) 
	fs:SetFont(STANDARD_TEXT_FONT, 11, "OUTLINE") 
	ilv[slotName] = fs 
end 
end 

for k, v in pairs(slot) do createIlvText("Character"..v.."Slot") end 

local function checkItem(unit, frame) 
if unit then 
for k, v in pairs(slot) do 
local itemLink = GetInventoryItemLink(unit, k) 
if itemLink then 
local _,_,itemQuality,itemLv = GetItemInfo(itemLink) 
local r,g,b = GetItemQualityColor(itemQuality) 
ilv[frame..v.."Slot"]:SetText(itemLv) 
ilv[frame..v.."Slot"]:SetTextColor(r,g,b) 
else 
ilv[frame..v.."Slot"]:SetText() 
end 
end 
end 
end 

_G["CharacterFrame"]:HookScript("OnShow", function(self) 
checkItem("player", "Character") 
self:RegisterEvent("UNIT_MODEL_CHANGED") 
end) 

_G["CharacterFrame"]:HookScript("OnHide", function(self) 
self:UnregisterEvent("UNIT_MODEL_CHANGED") 
end) 

_G["CharacterFrame"]:HookScript("OnEvent", function(self, event) 
if event == "UNIT_MODEL_CHANGED" then checkItem("player", "Character") end 
end) 

local F = CreateFrame("Frame") 
F:RegisterEvent("ADDON_LOADED") 
F:SetScript("OnEvent", function(self, event, addon) 
if addon == "Blizzard_InspectUI" then 
self:UnregisterEvent("ADDON_LOADED") 
self:SetScript("OnEvent", nil) 

for k, v in pairs(slot) do createIlvText("Inspect"..v.."Slot") end 
checkItem(_G["InspectFrame"].unit, "Inspect") 

_G["InspectFrame"]:HookScript("OnShow", function() 
self:RegisterEvent("INSPECT_READY") 
self:RegisterEvent("UNIT_MODEL_CHANGED") 
self:RegisterEvent("PLAYER_TARGET_CHANGED") 
self:SetScript("OnEvent", function() checkItem(_G["InspectFrame"].unit, "Inspect") end) 
end) 

_G["InspectFrame"]:HookScript("OnHide", function() 
self:UnregisterEvent("PLAYER_TARGET_CHANGED") 
self:UnregisterEvent("UNIT_MODEL_CHANGED") 
self:UnregisterEvent("INSPECT_READY") 
self:SetScript("OnEvent", nil) 
end) 

end 
end)
hooksecurefunc("ActionButton_OnUpdate", function(self, elapsed) 
   if ( self.rangeTimer == TOOLTIP_UPDATE_TIME and self.action) then 
      local range = false 
      if ( IsActionInRange(self.action) == false ) then 
         getglobal(self:GetName().."Icon"):SetVertexColor(1, 0, 0) 
         getglobal(self:GetName().."NormalTexture"):SetVertexColor(1, 0, 0) 
         range = true 
      end; 
      if ( self.range ~= range and range == false ) then 
         ActionButton_UpdateUsable(self) 
      end; 
      self.range = range 
   end 
end)

------------------------------------WorldMap CoordText------------------------------------
local Coordinates_UpdateInterval = 0.2
local timeSinceLastUpdate = 0
local color = "|cff00ffff"

-- Need a frame for events
local Coordinates_eventFrame = CreateFrame("Frame")
Coordinates_eventFrame:RegisterEvent("VARIABLES_LOADED")
Coordinates_eventFrame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
Coordinates_eventFrame:RegisterEvent("ZONE_CHANGED_INDOORS")
Coordinates_eventFrame:RegisterEvent("ZONE_CHANGED")
Coordinates_eventFrame:SetScript("OnEvent",function(self,event,...) self[event](self,event,...);end)

-- Create slash command
SLASH_COORDINATES1 = "/coordinates"
SLASH_COORDINATES2 = "/coord"

-- Handle slash commands
function SlashCmdList.COORDINATES(msg)
	msg = string.lower(msg)
	local command, rest = msg:match("^(%S*)%s*(.-)$")
	if (command == "worldmap" or command =="w") then
		if CoordinatesDB["worldmap"] == true then 
			CoordinatesDB["worldmap"] = false
			DEFAULT_CHAT_FRAME:AddMessage(color.."Coordinates: World map coordinates disabled")
		else
			CoordinatesDB["worldmap"] = true
			DEFAULT_CHAT_FRAME:AddMessage(color.."Coordinates: World map coordinates enabled")
		end
	elseif (command == "minimap" or command =="m") then
		if CoordinatesDB["minimap"] == true then 
			CoordinatesDB["minimap"] = false
			MinimapZoneText:SetText( GetMinimapZoneText() )
			DEFAULT_CHAT_FRAME:AddMessage(color.."Coordinates: Mini map coordinates disabled")
		else
			CoordinatesDB["minimap"] = true
			DEFAULT_CHAT_FRAME:AddMessage(color.."Coordinates: Mini map coordinates enabled")
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage(color.."Coordinates by Szandos")
		DEFAULT_CHAT_FRAME:AddMessage(color.."Version: "..GetAddOnMetadata("Coordinates", "Version"))
		DEFAULT_CHAT_FRAME:AddMessage(color.."Usage:")
		DEFAULT_CHAT_FRAME:AddMessage(color.."/coordinates worldmap - Enable/disable coordinates on the world map")
		DEFAULT_CHAT_FRAME:AddMessage(color.."/coordinates minimap - Enable/disable coordinates on the mini map")
	end
end

--Event handler
function Coordinates_eventFrame:VARIABLES_LOADED()
	if (not CoordinatesDB) then
		CoordinatesDB = {}
		CoordinatesDB["worldmap"] = true
		CoordinatesDB["minimap"] = true
	end
	Coordinates_eventFrame:SetScript("OnUpdate", function(self, elapsed) Coordinates_OnUpdate(self, elapsed) end)
end

function Coordinates_eventFrame:ZONE_CHANGED_NEW_AREA()
	Coordinates_UpdateCoordinates()
end

function Coordinates_eventFrame:ZONE_CHANGED_INDOORS()
	Coordinates_UpdateCoordinates()
end

function Coordinates_eventFrame:ZONE_CHANGED()
	Coordinates_UpdateCoordinates()
end

--OnUpdate
function Coordinates_OnUpdate(self, elapsed)
	timeSinceLastUpdate = timeSinceLastUpdate + elapsed
	if (timeSinceLastUpdate > Coordinates_UpdateInterval) then
		-- Update the update time
		timeSinceLastUpdate = 0
		Coordinates_UpdateCoordinates()
	end
end

function Coordinates_UpdateCoordinates()
	--MinimapCoordinates
	local mapID
	local position
	if (CoordinatesDB["minimap"] and Minimap:IsVisible()) then
		mapID = C_Map.GetBestMapForUnit("player")
		if (mapID) then
			position = C_Map.GetPlayerMapPosition(mapID,"player")
			if (position and position.x ~= 0 and position.y ~= 0 ) then
				MinimapZoneText:SetText( format("(%d:%d) ",position.x*100.0,position.y*100.0) .. GetMinimapZoneText() );
			end
		end
	end
	--WorldMapCoordinates
 	if (CoordinatesDB["worldmap"] and WorldMapFrame:IsVisible()) then
		-- Get the cursor's coordinates
		local cursorX, cursorY = GetCursorPosition()

		-- Calculate cursor position
		local scale = WorldMapFrame:GetCanvas():GetEffectiveScale()
		cursorX = cursorX / scale
		cursorY = cursorY / scale
		local width = WorldMapFrame:GetCanvas():GetWidth()
		local height = WorldMapFrame:GetCanvas():GetHeight()
		local left = WorldMapFrame:GetCanvas():GetLeft()
		local top = WorldMapFrame:GetCanvas():GetTop()
		cursorX = (cursorX - left) / width * 100
		cursorY = (top - cursorY) / height * 100
		local worldmapCoordsText = "Cursor(X,Y): "..format("%.1f , %.1f |", cursorX, cursorY)
		-- Player position
		if (not mapID) then
			mapID = C_Map.GetBestMapForUnit("player")
		end
		if (mapID) then
			position = C_Map.GetPlayerMapPosition(mapID,"player")
		end
		if (position and position.x ~= 0 and position.y ~= 0 ) then
			worldmapCoordsText = worldmapCoordsText.." Player(X,Y): "..format("%.1f , %.1f", position.x * 100, position.y * 100)
		else
			worldmapCoordsText = worldmapCoordsText.." Player(X,Y): n/a"
		end
		-- Add text to world map
		WorldMapFrame.BorderFrame.TitleText:SetText(worldmapCoordsText)
	elseif (WorldMapFrame:IsVisible()) then
		WorldMapFrame.BorderFrame.TitleText:SetText(MAP_AND_QUEST_LOG)
	end
end

if (TomCats and TomCats.Register) then
    TomCats:Register(
        {
            name = "Coordinates",
            version = "2.05"
        }
    )
end


------------------------------------Action icons turn red if out of range------------------------------------
hooksecurefunc("ActionButton_OnUpdate", function(self, elapsed) 
   if ( self.rangeTimer == TOOLTIP_UPDATE_TIME and self.action) then 
      local range = false 
      if ( IsActionInRange(self.action) == false ) then 
         getglobal(self:GetName().."Icon"):SetVertexColor(1, 0, 0) 
         getglobal(self:GetName().."NormalTexture"):SetVertexColor(1, 0, 0) 
         range = true 
      end; 
      if ( self.range ~= range and range == false ) then 
         ActionButton_UpdateUsable(self) 
      end; 
      self.range = range 
   end 
end)

-------------------------------------Interuption announcement------------------------------------
local AfterInterrupt = CreateFrame("Frame", nil, UIParent) 
AfterInterrupt:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED") 
local function InterruptUpdate(self, event, ...) 
   if event == "COMBAT_LOG_EVENT_UNFILTERED" then       
      local timestamp, eventType, _, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, _, spellID, spellName, _, extraskillID, extraSkillName = ... 
      if eventType == "SPELL_INTERRUPT" and sourceName == UnitName("player") then 
         SendChatMessage("Interrupted %t's "..GetSpellLink(extraskillID), "SAY")--Ƶ޸ 
      end 
   end 
end 
AfterInterrupt:SetScript("OnEvent", InterruptUpdate)



------------------------------------hide healing texture------------------------------------

PlayerHitIndicator:SetText(nil) 
PlayerHitIndicator.SetText = function() end

------------------------------------Say Sapped------------------------------------

local SaySapped = CreateFrame("Frame")
SaySapped.playername = UnitName("player")

SaySapped:SetScript("OnEvent", function(_,_,_,event, _,_,sourceName, _,_,_,destName, _,_,spellId)
	if ((spellId == 6770)
	and (destName == SaySapped.playername)
	and (event == "SPELL_AURA_APPLIED" or event == "SPELL_AURA_REFRESH"))
	then
		SendChatMessage("Sapped","SAY")
		DEFAULT_CHAT_FRAME:AddMessage("Sapped by: "..(sourceName or "(unknown)"))
	end
end)

SaySapped:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
DEFAULT_CHAT_FRAME:AddMessage("SaySapped loaded")

------------------------------------Combat Status Display------------------------------------
local t = CreateFrame("Frame", UIParent) 
t.t = t:CreateTexture() 
t.t:SetTexture("Interface\\CHARACTERFRAME\\UI-StateIcon.blp") 
t.t:SetTexCoord(0.5,1,0,0.49); 
t.t:SetAllPoints(t) 
t:SetWidth(35) 
t:SetHeight(35) 
t:SetPoint("CENTER", TargetFrame, "RIGHT", -20, -15) -----Ŀλ 
t:Show() 

local function FrameOnUpdate(self) 
if UnitAffectingCombat("target") then 
self:Show() 
else 
self:Hide() 
end 
end 
local g = CreateFrame("Frame") 
g:SetScript("OnUpdate", function(self) FrameOnUpdate(t) end) 

local f = CreateFrame("Frame", UIParent) 
f.t = f:CreateTexture() 
f.t:SetTexture("Interface\\CHARACTERFRAME\\UI-StateIcon.blp") 
f.t:SetTexCoord(0.5,1,0,0.49); 
f.t:SetAllPoints(f) 
f:SetWidth(35) 
f:SetHeight(35) 
f:SetPoint("CENTER", FocusFrame, "RIGHT", -20, -15) ---λ 
f:Show() 

local function FrameOnUpdateFocus(self) 
if UnitAffectingCombat("focus") then 
self:Show() 
else 
self:Hide() 
end 
end 
local g = CreateFrame("Frame") 
g:SetScript("OnUpdate", function(self) FrameOnUpdateFocus(f) end)